<template>
    <div id="home" @load="getDocuments()">
        <NavBar></NavBar>
        <div v-if="!detailMode" id="document-list-wrapper" class="page-wrap">
            <div v-for="(document, index) in documents" class="document-wrapper" @click="showDetails(document)">
                <img src="https://static.thenounproject.com/png/1203585-200.png"
                     alt="todo" width="50" height="50">
                <div class="m-2">Document {{index + 1}}</div>
                <div class="m-2"><small>Last Edit: {{document.updatedAt | moment("DD/MM/YYYY - hh:mm:ss")}}</small>
                </div>
            </div>
        </div>
        <div v-else class="page-wrap text-left">
            <div>
                <div class="m-3">
                    <div><b>Document Template</b></div>
                    <div class="doc-template">{{currentDocument.body}}</div>
                </div>

                <div class="m-3">
                    <div class="row">
                        <div class="col-md-3" v-for="(value, key) in currentDocument.fields">
                            <label :for="key" class="col-md-2 col-form-label"><b>{{key}}</b></label>
                            <div class="col-md-10">
                                <input type="text" class="form-control" :id="key" placeholder=""
                                       v-model="currentDocument.fields[key]">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="m-3">
                    <label for="output"><b>Output Document</b></label>
                    <textarea id="output" class="form-control" v-model="outputDocument" rows="6"
                              disabled></textarea>
                </div>

                <div class="m-3 text-right">
                    <button class="btn btn-outline-danger mr-2" @click="showDocumentList()">🔙 Back to List</button>
                    <button class="btn btn-outline-danger" @click="saveCurrentDocument()">💾 Save Document</button>
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
    import {Component, Vue} from "vue-property-decorator";
    import NavBar from "@/components/NavBar.vue";
    import {AuthUtils} from "@/utils/auth-utils";
    import {AxiosResponse} from "axios";
    import DocumentDto from "@/models/document.model";
    import DocumentParser from "@/utils/document-parser";

    @Component({
        components: {
            NavBar,
        },
    })
    export default class Home extends Vue {

        public documents: DocumentDto[] = [];

        public currentDocument: DocumentDto = {};

        created() {
            this.getDocuments();
        }

        public getDocuments(): void {
            this.$http
                .get("http://localhost:8080/api/documents", AuthUtils.authorizedHeader())
                .then((response: AxiosResponse) => {
                    const data: DocumentDto[] = response.data;
                    data.forEach((doc, idx) => {
                        doc.id = idx + 1;
                        const allFields: string[] = DocumentParser.getAllFields(doc.body || "");
                        allFields.filter(field => !doc.fields.hasOwnProperty(field)).forEach(field => doc.fields[field] = "");
                    });
                    this.documents = JSON.parse(JSON.stringify(data));
                })
                .catch(error => {
                    alert(`😖 ${error.response.data.message}`);
                });
        }

        public showDetails(document: DocumentDto) {
            this.currentDocument = JSON.parse(JSON.stringify(document));
        }

        public showDocumentList() {
            this.currentDocument = {};
        }

        public saveCurrentDocument() {
            this.documents = this.documents.filter(doc => doc.id !== this.currentDocument.id);
            this.currentDocument.updatedBy = AuthUtils.username();
            this.currentDocument.updatedAt = new Date();
            this.documents.push(this.currentDocument);
            this.showDocumentList();
        }

        get detailMode(): boolean {
            return !!this.currentDocument.id;
        }

        get outputDocument(): string {
            return !!this.currentDocument.body ? DocumentParser.parseDocument(this.currentDocument) : "";
        }
    }
</script>

<style scoped lang="scss">
    #home {
        background-color: snow;

        .page-wrap {
            margin-top: 5em;
            overflow: auto;
        }

        #document-list-wrapper {
            overflow: auto;
            display: flex;
            flex-wrap: wrap;

            .document-wrapper {
                max-width: 15em;
                border: 1px solid gray;
                border-radius: 0.5em;
                cursor: pointer;
                padding: 2em;
                margin: 4em;
                background-color: snow;

                &:hover {
                    background-color: rgba(244, 255, 0, 0.46);
                    border: 1px solid #ff1c16;
                }
            }
        }

        .doc-template {
            padding: 2em;
            background-color: white;
            border: 1px solid #ff1c16;
        }

        textarea {
            resize: none;
        }

        label {
            white-space: nowrap;
        }

    }

</style>
